{
  Solutions to the Advent Of Code.
  Copyright (C) 2023  Stefan Müller

  This program is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  this program.  If not, see <http://www.gnu.org/licenses/>.
}

unit UAplentyTestCases;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, fpcunit, testregistry, USolver, UBaseTestCases, UAplenty;

type

  { TAplentyExampleTestCase }

  TAplentyExampleTestCase = class(TExampleEngineBaseTest)
  protected
    function CreateSolver: ISolver; override;
  published
    procedure TestPart1;
    procedure TestPart2;
  end;

implementation

{ TAplentyExampleTestCase }

function TAplentyExampleTestCase.CreateSolver: ISolver;
begin
  Result := TAplenty.Create;
end;

procedure TAplentyExampleTestCase.TestPart1;
begin
  AssertEquals(19114, FSolver.GetResultPart1);
end;

procedure TAplentyExampleTestCase.TestPart2;
begin
  AssertEquals(167409079868000, FSolver.GetResultPart2);
end;

initialization

  RegisterTest('TAplenty', TAplentyExampleTestCase);
end.

